
<template>
  <div>
    <vue-element-loading :active="loading" spinner="spinner" color="#FF6700" :is-full-screen="true" backgroundColor="rgba(255,255,255,.25)"/>
    
    <v-toolbar color="primary" dark fixed app flat  scroll-off-screen>
        <v-toolbar-side-icon @click.stop="drawer = !drawer"></v-toolbar-side-icon>
        <v-toolbar-title>
            <v-breadcrumbs dark :items="breadcrumbItems" divider=">" class="cursive breadcrumb" />
        </v-toolbar-title>
        
        <v-spacer />
        
        <SearchMenu />
        
        <v-btn dark flat right small icon class="pr-0  mr-0" @click="getApplications()"><v-icon style="vertical-align:bottom;font-size:20px">refresh</v-icon></v-btn>
    </v-toolbar>

    <NavDrawer :drawer="drawer" @update="drawer = $event" />
  
    <v-content class="board" fill-height>
        <v-layout row wrap class="white--text text-xs-center">
            
            <v-flex xs12 sm4>
                <StatusLane id="SAVED" class="hidden-xs-only" :scope="localScope" :maxLaneItems="maxLaneItems"
                            titleColor="rgba(255,255,255,.6)" :title="inactiveLaneTitle" :total="items.saved.total"
                            :items="items.saved.content" @collectionChange="collectionChange">
                    <div slot="title" class="text-xs-center"><span id="saved-sm">{{inactiveLaneTitle}}</span></div>
                </StatusLane>
                <StatusLane id="IN_PROGRESS" class="hidden-sm-and-up"  :maxLaneItems="maxLaneItems"
                            :title="activeLaneTitle" :scope="localScope" :total="items.inProgress.total"
                            :items="items.inProgress.content" @collectionChange="collectionChange">
                    <div slot="title" class="text-xs-center"><span id="in_progress-xs">{{activeLaneTitle}}</span></div>
                </StatusLane>
            </v-flex>
            <v-flex xs12 sm4>
                <StatusLane id="APPLIED" :scope="localScope" :maxLaneItems="maxLaneItems"
                            titleColor="rgba(255,255,255,.75)" :title="appliedLaneTitle" :total="items.applied.total"
                            :items="items.applied.content" @collectionChange="collectionChange">
                   <div slot="title" class="text-xs-center"><span id="applied-all">{{appliedLaneTitle}}</span></div>
                </StatusLane>
            </v-flex>
            <v-flex xs12 sm4>
                <StatusLane id="IN_PROGRESS" class="hidden-xs-only" :maxLaneItems="maxLaneItems"
                            :title="activeLaneTitle" :scope="localScope" :total="items.inProgress.total"
                            :items="items.inProgress.content" @collectionChange="collectionChange">
                    <div slot="title" class="text-xs-center"><span id="in_progress-sm">{{activeLaneTitle}}</span></div>
                </StatusLane>
                <StatusLane id="SAVED" class="hidden-sm-and-up" :scope="localScope" :maxLaneItems="maxLaneItems"
                            titleColor="rgba(255,255,255,.6)" :title="inactiveLaneTitle" :total="items.saved.total"
                            :items="items.saved.content" @collectionChange="collectionChange">
                    <div slot="title" class="text-xs-center"><span id="saved-xs">{{inactiveLaneTitle}}</span></div>
                </StatusLane>
            </v-flex>
      </v-layout>
      <v-btn fixed dark fab bottom right color="accent"  @click="applicationDialog = true" id="create-app-btn">
        <v-icon>add</v-icon>
      </v-btn>
    </v-content>
    
    <v-layout row justify-center>
        <v-dialog v-model="applicationDialog" persistent fullscreen hide-overlay transition="dialog-bottom-transition">
            <ApplicationWizard :title="$i18n.t('application.form.newApplication')" :scope="localScope"
                    :model="applicationDialog" @save="addItem" @success="showSnackbar"
                    @error="showSnackbar({message: 'Could not save application', color: 'error'})"
                    v-model="application" @cancel="applicationDialog = false" @close="applicationDialog = false"/>
        </v-dialog>
    </v-layout>
    
    
    <v-snackbar v-model="snack.show" :timeout="snack.duration" :color="snack.color">
      {{ snack.message }}
      <v-btn flat @click="snack.show = false">{{ $i18n.t("common.close") }}</v-btn>
    </v-snackbar>
        
    <v-tour name="boardTour" :steps="tourSteps" :options="tourOptions" :callbacks="tourCallbacks"></v-tour>
    
 </div>
</template>

<script>
import SearchMenu from '../components/SearchMenu.vue' 
import VueElementLoading from 'vue-element-loading'
import NavDrawer from '../components/NavDrawer.vue'
import StatusLane from '../components/application/board/StatusLane'
import ApplicationWizard from '../components/application/forms/ApplicationWizard'
import moment from 'moment'
export default {
  name: 'board',
  components: {
    VueElementLoading,
    NavDrawer,
    StatusLane,
    ApplicationWizard,
    SearchMenu
  },
  props: {
    applicationTemplate: {
        type: Object,
        //not sure the default is still useful. Keep it from now even though it has a side effect on the empty company combo 
        default:  () => { return { title: null, listingUrl: null, company: {}, contact: {}, notes: [{}], status: 'APPLIED' }; }
    },
    scope: {
        type: String,
        default: 'default'
    },
    initialState: {
        type: Object,
        default: () => { 
          return {
            saved: { content: [], total: 0 },
            applied: { content: [], total: 0 },
            inProgress: { content: [], total: 0 }
          }
        }
    }
  },
  data() {
    return {
        maxLaneItems: 4,
        items: this.initialState,
        localScope: this.scope,
        drawer: false,
        loading: false,
        snack: {
            duration: 2000,
            message: this.$i18n.t("common.applicationSaved"),
            color: 'success',
            show: false
        },
        applicationDialog: false,
        application: this.applicationTemplate,
        tourCallbacks: {
            onNextStep: (currentStep) => {
                this.$api.updateUser({ 
                    onboarding: {
                        generalOnboardingStep: currentStep + 1
                    }
                })
            },
            onPreviousStep: (currentStep) => {
                this.$api.updateUser({ 
                    onboarding: {
                        generalOnboardingStep: currentStep - 1
                    }
                })
            },
            onStop: () => { 
                this.$api.updateUser({ 
                    onboarding: {
                        generalOnboardingStep: this.tourSteps.length - 1
                    }
                })
            }
        }
    }
  },
  methods: {
    collectionName(status) {
      return status == 'IN_PROGRESS' ? 'inProgress': status.toLowerCase()
    },
    addItem(application, saved) {
      this.applicationDialog = false
      const status = this.collectionName(application.status)
      let items = this.items[status].content
      if ( saved ) {
          items.splice(0, 1, application)
          this.application = this.applicationTemplate
      }
      else {
          items.push(this.application)
      }
      items.sort((a, b) => moment(b.lastUpdate).valueOf() - moment(a.lastUpdate).valueOf() )
    },
    showSnackbar(params) {
        const options = this.snack 
        if ( options ) {
            Object.assign(this.snack, params || {  })
        }
        this.snack.show = true
        Object.assign(this.snack, options)
    },
    collectionChange(item, oldStatus, newStatus) {
      let oldColl = this.items[this.collectionName(oldStatus)]
      oldColl.content = oldColl.content.filter(o => o.id != item.id)
      oldColl.total -= 1
      if (newStatus) {
          let newColl = this.items[this.collectionName(newStatus)]
          if ( newColl )  {
              newColl.content.splice(0, 0, item)
              newColl.total += 1
              newColl.content.sort((a, b) => moment(b.lastUpdate).valueOf() - moment(a.lastUpdate).valueOf() )
          }
      }
    },
    getApplications() {
        this.items = this.initialState
        this.loading = true
        this.loadPage()
    },
    loadPage() {
        Promise.all([
            this.$api.getApplicationsAsync({size: this.maxLaneItems, page: 0, status: 'SAVED'}),
            this.$api.getApplicationsAsync({size: this.maxLaneItems, page: 0, status: 'APPLIED'}),
            this.$api.getApplicationsAsync({size: this.maxLaneItems, page: 0, status: 'IN_PROGRESS'})
        ])
        .then((result) => {
            this.items.saved = { content: result[0].content, total: result[0].totalElements }
            this.items.applied = { content: result[1].content, total: result[1].totalElements }
            this.items.inProgress = { content: result[2].content, total: result[2].totalElements }
        })
        .catch((e) => {
            this.$logger.error(e);
        })  
        .finally(() => {
            this.loading = false
        })
    }
  },
  computed: {
    inactiveLaneTitle() {
        return this.$i18n.t("board.inactive")
    },
    appliedLaneTitle() {
        return this.$i18n.t("board.applied")
    },
    activeLaneTitle() {
        return this.$i18n.t("board.active")
    },
    breadcrumbItems() { 
        return [
            {
              text: this.$i18n.t("menu.board"),
              disabled: true
            }
        ]
    },
    tourSteps() {
        return  [
            {
              target: "#create-app-btn",
              content: this.$i18n.t("board.instructions.create")
            }, 
            {
              target: this.$vuetify.breakpoint.xs ? "#in_progress-xs" : "#in_progress-sm",
              content: this.$i18n.t("board.instructions.status.default")
            },
            {
              target: "#applied-all",
              content: this.$i18n.t("board.instructions.status.drag")
            },
            {
              target: this.$vuetify.breakpoint.xs ? "#saved-xs" : "#saved-sm",
              content: this.$i18n.t("board.instructions.status.type")
            }
        ]
    },
    tourOptions() {
        return {
            useKeyboardNavigation: false,
            labels: {
              buttonSkip: this.$i18n.t("tour.labels.skip"),
              buttonPrevious: this.$i18n.t("tour.labels.prev"),
              buttonNext: this.$i18n.t("tour.labels.next"),
              buttonStop: this.$i18n.t("tour.labels.done")
            }
        }
    }
  },
  mounted: async function() { 
    this.getApplications();
    const user = await this.$api.getUser()
    if ( !user.onboarding || user.onboarding.generalOnboardingStep < this.tourSteps.length - 1 ) {
        this.$tours['boardTour'].start(!user.onboarding ? 0 : user.onboarding.generalOnboardingStep)
    }
  } 
    
};
</script>


